
/*   $Revision: 1.7 $ */
/*   $Date: 2005/09/13 23:27:41 $ */

#ifndef _CPXCTRL_H_

#define _CPXCTRL_H_

#define VERSION "0.2.5"

// error codes
#define ERR_NOLOCK	-2	// a lock couldn't be taken, retry later
#define ERR_FATAL	-1	// some sort of fatal error occured
#define ERR_TIMEOUT	-4	// a timeout occured, which shouldn't have
#define ERR_ALLOC	-8	// an allocation error occured
#define ERR_FILE	-16	// a file op error occured

#define FRAME_NAME_SIZE 128

extern int debug_level;

#define err_printf(format, args...) fprintf(stderr, format, ## args)
#define info_printf(format, args...) if (debug_level >= 0) fprintf(stderr, format, ## args)
// print function for level 1 debug
#define d1_printf(format, args...) if (debug_level >= 1) fprintf(stderr, format, ## args)
// print function for level 2 debug
#define d2_printf(format, args...) if (debug_level >= 2) fprintf(stderr, format, ## args)
// print function for level 3 debug
#define d3_printf(format, args...) if (debug_level >= 3) fprintf(stderr, format, ## args)

/* clamp functions */
static inline int clamp_double(double *val, double min, double max)
{
	if (*val < min) {
		*val = min;
		return 1;
	}
	if (*val > max) {
		*val = max;
		return 1;
	}
	return 0;
}

static inline int clamp_int(int *val, int min, int max)
{
	if (*val < min) {
		*val = min;
		return 1;
	}
	if (*val > max) {
		*val = max;
		return 1;
	}
	return 0;
}

#endif // _CPXCTRL_H_
